package cn.iocoder.yudao.module.system.service.tenantagencypackage;

import java.util.*;
import javax.validation.*;
import javax.validation.constraints.NotNull;

import cn.iocoder.yudao.module.system.controller.admin.tenantagencypackage.vo.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.system.dal.dataobject.tenantagencypackage.TenantAgencyPackageDO;

/**
 * 代理租户套餐 Service 接口
 *
 * @author 总后台
 */
public interface TenantAgencyPackageService {

    /**
     * 创建代理租户套餐
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createTenantAgencyPackage(@Valid TenantAgencyPackageSaveReqVO createReqVO);

    /**
     * 更新代理租户套餐
     *
     * @param updateReqVO 更新信息
     */
    void updateTenantAgencyPackage(@Valid TenantAgencyPackageSaveReqVO updateReqVO);

    /**
     * 删除代理租户套餐
     *
     * @param id 编号
     */
    void deleteTenantAgencyPackage(Long id);

    /**
    * 批量删除代理租户套餐
    *
    * @param ids 编号
    */
    void deleteTenantAgencyPackageListByIds(List<Long> ids);

    /**
     * 获得代理租户套餐
     *
     * @param id 编号
     * @return 代理租户套餐
     */
    TenantAgencyPackageDO getTenantAgencyPackage(Long id);

    /**
     * 获得代理租户套餐分页
     *
     * @param pageReqVO 分页查询
     * @return 代理租户套餐分页
     */
    PageResult<TenantAgencyPackageDO> getTenantAgencyPackagePage(TenantAgencyPackagePageReqVO pageReqVO);

    TenantAgencyPackageDO validTenantPackage(@NotNull(message = "租户套餐编号不能为空") Long packageId);

    List<TenantAgencyPackageDO> getTenantPackageListByStatus(Integer status);
}